package com.oracle.ateam.gziputils;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.HttpEntity;
import org.apache.http.HttpException;
import org.apache.http.HttpRequest;
import org.apache.http.HttpRequestInterceptor;
import org.apache.http.HttpResponse;
import org.apache.http.HttpResponseInterceptor;
import org.apache.http.client.entity.GzipDecompressingEntity;
//import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.InputStreamEntity;
import org.apache.http.impl.client.DefaultHttpClient;
//import org.apache.http.ParseException;
import org.apache.http.protocol.HttpContext;
import org.apache.http.util.EntityUtils;


public class GzipHttpClient {
	  
	  private static final String CONTENT_TYPE = "text/xml;charset=UTF-8";
	  private static final String ENCODING= "gzip, deflate";

	  
	  public void gExecute( String endpoint,
	            InputStream request, OutputStream ServletResponse)
	  {
	    DefaultHttpClient httpclient = new DefaultHttpClient();
	    try
	    {
	    	httpclient.addRequestInterceptor(new HttpRequestInterceptor()
	        {

	          public void process(final HttpRequest request, final HttpContext context)
	            throws HttpException, IOException
	            {
	        	  if (!request.containsHeader("Accept-Encoding"))
	        	  {
	        		  request.addHeader("Accept-Encoding", ENCODING);
	        	  }
	        	  if (!request.containsHeader("Content-Type"))
	        	  {
	        		  request.addHeader("Content-Type", CONTENT_TYPE);
	        	  }
	            }

	        });

	    	httpclient.addResponseInterceptor(new HttpResponseInterceptor()
	        {

	    		public void process(final HttpResponse response, final HttpContext context)
	            	throws HttpException, IOException
	            {
	    			HttpEntity entity = response.getEntity();
	    			if (entity != null)
	    			{
	    				Header ceheader = entity.getContentEncoding();
	    				if (ceheader != null)
	    				{
	    					HeaderElement[] codecs = ceheader.getElements();
	    					for (int i = 0; i < codecs.length; i++)
	    					{
	    						if (codecs[i].getName().equalsIgnoreCase("gzip"))
	    						{
	    							response.setEntity(new GzipDecompressingEntity(response.getEntity()));
	    							return;
	    						}
	    					}
	    				}
	    			}
	            }

	        });


	      HttpPost httppost = new HttpPost(endpoint);
	      InputStreamEntity reqEntity = new InputStreamEntity(request, -1);
	      reqEntity.setContentType("binary/octet-stream");
	      reqEntity.setChunked(true);

	      httppost.setEntity(reqEntity);
	      HttpResponse httpResponse = httpclient.execute(httppost);
	      HttpEntity entity = httpResponse.getEntity();
	      
	      ServletResponse.write(EntityUtils.toByteArray(entity));
	      
	    }
	    catch (Exception e)
	    {
	      e.printStackTrace();
	    }
	    finally
	    {
	      httpclient.getConnectionManager().shutdown();
	    }
	  }
	  
	  
	  public static void copyStream(InputStream is, OutputStream os, int bufferSize) throws IOException 
	  {
	      byte[] buffer = new byte[bufferSize];
	      int bytesRead;
	      while ((bytesRead = is.read(buffer)) != -1) 
	      {
	          os.write(buffer, 0, bytesRead);
	      }
	  }
}
