package com.oracle.ateam.gziputils;

import java.io.IOException;
import java.io.InputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;

/**
 * Servlet implementation class GzipServlet
 */
public class GzipServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
	private static final String CONTENT_TYPE = "text/html; charset=windows-1252";
	private static final String XML_CONTENT_TYPE = "text/xml;charset=UTF-8";
	private static final String VERSION = "1.1";
	private GzipHttpClient client = null;

	  
    /**
     * @see HttpServlet#HttpServlet()
     */
    public GzipServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	    response.setContentType(CONTENT_TYPE);
	    PrintWriter out = response.getWriter();
	    out.println("<html>");
	    out.println("<head><title>Gzip servlet</title></head>");
	    out.println("<body>");
	    out.println("<p>The GZIP New Version " + VERSION + " is up and running </p>");
	    out.println("</body></html>");
	    out.close();
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try
	    {
			response.setContentType(XML_CONTENT_TYPE);

			String endpoint = request.getParameter("endpoint");
	      
			if (endpoint == null)
				throw new Exception ();

			InputStream requestStream = request.getInputStream();

			client = new GzipHttpClient();
			client.gExecute(endpoint,requestStream,response.getOutputStream());
	    }
	    catch (Exception e)
	    {
	      e.printStackTrace();
	    }
	}

}
